--- old/usr/src/uts/common/inet/ip/ip_output.c	2012-07-09 14:38:17.592060091 +0000
+++ new/usr/src/uts/common/inet/ip/ip_output.c	2012-07-09 14:38:17.616088670 +0000
@@ -1648,6 +1648,9 @@
 #endif
 			sctph->sh_chksum = sctp_cksum(mp, ip_hdr_length);
 		goto ip_hdr_cksum;
+	} else if (protocol == IPPROTO_DCCP) {
+		cksump = IPH_DCCPH_CHECKSUMP(ipha, ip_hdr_length);
+		cksum = IP_DCCP_CSUM_COMP;
 	} else {
 		goto ip_hdr_cksum;
 	}
@@ -1737,6 +1740,9 @@
 #endif
 			sctph->sh_chksum = sctp_cksum(mp, ip_hdr_length);
 		goto ip_hdr_cksum;
+	} else if (protocol == IPPROTO_DCCP) {
+		cksump = IPH_DCCPH_CHECKSUMP(ipha, ip_hdr_length);
+		cksum = IP_DCCP_CSUM_COMP;
 	} else {
 	ip_hdr_cksum:
 		/* Calculate IPv4 header checksum */
